function [ dist, path ] = dijkstra( M, a, b )
%DIJKSTRA Calculates the geodesic distance and path between the vertices
% a and b on M. dist is a scalar value and path a vector of vertex
% indices such that path(1) = a and path(end) = b.

n = size(M.VERT,1);
m = size(M.TRIV,1);

incidence = incidenceMatrix(M.TRIV);

% inititialisations
heap = MinHeap(n);

heap.push(0, a);
for i=1:n
   heap.push(Inf, i); 
end

distances = -1*ones(n,1);
predecessors = zeros(n,1);

% run dijkstra
while(~heap.isEmpty())
   % include your code here!
end

% extract distance and path 
dist = ?;
path = ?;

end

